Subject: RE: [Megaco] Query on ASN grammer

From: "Rashim Anand" <[email-masked]>
Date: Mon, 31 Oct 2005 11:06:49 -0800

Hi,

I have a doubt wrt encoding of descriptors in AmmRequest. If the
descriptors in AmmRequest are absent, then how would the message be
binary encoded -
*	Would the tag for AmmRequest be present along with length = 0 to
indicate the absence of the descriptors.
*	OR would the tag for AmmRequest be absent altogether to indicate
the absence of the descriptors?

What exactly is meant by a NULL sequence? Does this mean a "sequence of"
tag along with length = 0?

Regards,
-Rashim Anand

-----Original Message-----
From: Christian Groves [mailto:[email-masked]] 
Sent: Friday, October 14, 2005 12:12 AM
To: Rashim Anand
Cc: Deepak Pokharna; [email-masked]
Subject: Re: [Megaco] Query on ASN grammer

Hello Rashim,

I not sure that we can just retrospectively had optionals to the ASN.1. 
My understanding is that this would not be backwards compatible.

Christian

Rashim Anand wrote:

>Hi Christian,
>
>I think that for consistency and clarity purposes "OPTIONAL" should be 
>specified. There are other examples of using "OPTIONAL" in SEQUENCE OF 
>s which are optional in the spec. One such example is -
>
>ContextRequest ::== SEQUENCE
>{
>   priority       INTEGER(0..15) OPTIONAL,
>   emergency      BOOLEAN OPTIONAL,
>   topologyReq    SEQUENCE OF TopologyRequest OPTIONAL,
>   ...
>}
>
>This will prevent some confusion.
>-Rashim Anand
>
>
>
>
>-----Original Message-----
>From: [email-masked] [mailto:[email-masked]] On 
>Behalf Of Christian Groves
>Sent: Thursday, October 13, 2005 8:06 PM
>To: Deepak Pokharna
>Cc: [email-masked]
>Subject: Re: [Megaco] Query on ASN grammer
>
>
>Hello Depak,
>
>I'm not sure what the problem is. AmmRequest contains a "SEQUENCE OF"
>descriptors. The note simply says that you shouldn't have 2 or more of 
>the same descriptors per command. My understanding is that a sequence
of
>
>could be a null sequence.
>
>Christian
>
>Deepak Pokharna wrote:
>
>  
>
>>Hi
>>
>>     According to V2 Draft (ASN Grammar) it says at most one 
>>descriptor is required in list of descriptor in AmmRequest..But it has
>>    
>>
>
>  
>
>>not made the descriptors as optional too so it means one Descriptor
>>should be there in Add, Move and Mod Request. Here it has difference 
>>from ABNF grammar which have made the list of descriptor as optional. 
>>Can some one clarify this.
>>
>> 
>>
>>      Command ::= CHOICE
>>
>>      {
>>
>>         addReq               AmmRequest,
>>
>>         moveReq              AmmRequest,
>>
>>         modReq               AmmRequest,
>>
>>         -- Add, Move, Modify requests have the same parameters
>>
>>         subtractReq          SubtractRequest,
>>
>>         auditCapRequest      AuditRequest,
>>
>>         auditValueRequest    AuditRequest,
>>
>>         notifyReq            NotifyRequest,
>>
>>         serviceChangeReq     ServiceChangeRequest,
>>
>>         ...
>>
>>      }
>>
>>      
>>
>>      
>>
>>      AmmRequest ::= SEQUENCE
>>
>>      {
>>
>>         terminationID        TerminationIDList,
>>
>>         */descriptors          SEQUENCE OF AmmDescriptor/*,
>>
>>*         -- At most one descriptor of each type (see AmmDescriptor) *
>>
>>*         -- allowed in the sequence. *
>>
>>*         ... *
>>
>>   
>>
>>   
>>
>>   Groves et al            Expires - October 2003              [Page
>>    
>>
>103]
>  
>
>>                         Megaco Protocol version 2            April
>>    
>>
>2003
>  
>
>>   
>>
>>   
>>
>>      }
>>
>>      
>>
>>      AmmDescriptor ::= CHOICE
>>
>>      {
>>
>>         mediaDescriptor         MediaDescriptor,
>>
>>         modemDescriptor         ModemDescriptor,
>>
>>         muxDescriptor           MuxDescriptor,
>>
>>         eventsDescriptor        EventsDescriptor,
>>
>>         eventBufferDescriptor   EventBufferDescriptor,
>>
>>         signalsDescriptor       SignalsDescriptor,
>>
>>         digitMapDescriptor      DigitMapDescriptor,
>>
>>         auditDescriptor         AuditDescriptor,
>>
>>         ...
>>
>>      }
>>
>> 
>>
>>Regards
>>
>>Deepak
>>
>> 
>>
>>----------------------------------------------------------------------
>>-
>>-
>>
>>_______________________________________________
>>Megaco mailing list
>>[email-masked]
>>https://www1.ietf.org/mailman/listinfo/megaco
>> 
>>
>>    
>>
>
>
>
>_______________________________________________
>Megaco mailing list
>[email-masked]
>https://www1.ietf.org/mailman/listinfo/megaco
>
>
>  
>

_______________________________________________
Megaco mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/megaco